## Contributing to Hangar

Take a look at the [README building section](README.md#Building) for info on how to set up the project.\
A general list of todos can be found in the [Roadmap Project](https://github.com/PaperMC/Hangar/projects/1).

## General Policy
Don't make the code look like it comes from a one-time contributor,
but embed it sanely into the surrounding code.
Changes should be easy to maintain and understand (with telling names and comments),
and when in doubt, ask other contributors if your idea makes sense/nobody else is working on it already. 

## Formatting
Nothing crazy here:
* Use 4 spaces (not tabs) as indention
* Leave an empty line between class headers and their first field
* Always use braces for single line ifs, for loops, etc.

Other than that, we follow [Oracle's standard code conventions](https://www.oracle.com/java/technologies/javase/codeconventions-contents.html) (e.g. IntelliJ's auto formatting).